#!/usr/bin/env python3 
# PCLISH - Python Command Line Shell

import os
import subprocess
import psutil
import platform
import socket

from bin.cd import *
from bin.mkdir import *
from bin.oscmd import *
from bin.help import *
from bin.echo import *


PROMPT = "shell@pclishOS "

def execute_command(command):
    try:
        if "|" in command:
            s_in, s_out = (0, 0)
            s_in = os.dup(0)
            s_out = os.dup(1)

            fdin = os.dup(s_in)
            
            for cmd in command.split("|"):
                os.dup2(fdin, 0)
                os.close(fdin)

                if cmd == command.split("|")[-1]:
                    fdout = os.dup(s_out)
                else:
                    fdin, fdout = os.pipe()

                os.dup2(fdout, 1)
                os.close(fdout)

                try:
                    subprocess.run(cmd.strip().split())
                except Exception:
                    print("pclish: command not found, run the help command for a list of commands: {}".format(cmd.strip()))

            os.dup2(s_in, 0)
            os.dup2(s_out, 1)
            os.close(s_in)
            os.close(s_out)
        else:
            subprocess.run(command.split(" "))
    except Exception:
        print("pclish: command not found: {}".format(command))

def main():
    while True:
        inp = input(PROMPT)
        if inp == "exit":
            break
        elif inp == "cd ":
            cd()
        elif inp == "help":
            help()
        elif inp == "mkdir ":   
            mkdir()
        elif inp == "system":
            system()
        elif inp == "echo":
            echo(txt)
        elif inp == "oscmd ":
            oscmd()
        else:
            execute_command(inp)

#  Main
if '__main__' == __name__:
    main()
